#include once "forms.bi"
#include once "commdlgs.bi"

#inclib "forms"
#inclib "commdlgs"

dim shared as TForm Form, MDIForm(3),_Frm

Form.Main = 1

for i as integer = 0 to ubound(MDIForm)-1
    MDIForm(i).FormStyle = 2
next i

static as TMainMenu Menu
static as TMenuItem MenuFile, MenuNew, MenuOpen, MenuSave, MenuSaveAs, N1, MenuExit,MenuWindows,MenuCascade,MenuArrange,MenuTile

sub NewClick
    dim as PForm F = new TForm
    with *F
       .FormStyle = fsMDIChild
       .Color     = 255
       .Parent    = Form
    end with
    MessageBox(Form.Handle,"" & Form.ChildCount,"",0)
end sub

sub OpenClick
    static as TOpenDialog OpenDialog = TOpenDialog(@Form)
    OpenDialog.Filter    = "Text File (*.txt)|*.txt|All Files (*.*)|*.*"
    OpenDialog.Options or= ofEnableSizing 
    if OpenDialog.Execute then
        Form.Text = OpenDialog.FileName
    end if
    Form.Child(0) = _Frm
end sub

sub ExitClick
    MessageBox(Form.Handle,"=" & Form.ControlCount & " " & Form.Control(0)->ClassName,"",0)
    PostQuitMessage(0)
end sub

sub CascadeClick
    Form.Cascade
end sub

sub ArrangeClick
    Form.Arrange
end sub

sub TileClick
    Form.Tile
end sub

sub FormClose(sender as TForm,byref CloseAction as integer)
    if MessageBox(Form.Handle,"Close Form ?","TForm",MB_YESNO or MB_ICONQUESTION)=IDNO then
        CloseAction = 0
    end if
end sub

sub DialogClose(sender as TDialog,byref CloseAction as integer)
    if MessageBox(Form.Handle,"Close Dialog ?","TDialog",MB_YESNO or MB_ICONQUESTION)=IDNO then
        CloseAction = 0
    end if
end sub


MenuFile.Caption   = "File" 
MenuNew.Caption    = "New" 
MenuNew.onClick    = @NewClick
MenuOpen.Caption   = "Open"  
MenuOpen.onClick   = @OpenClick
MenuSave.Caption   = "Save"  
MenuSaveAs.Caption = "Save As..."  
N1.Caption         = "-"  
MenuExit.Caption   = "Exit" 
MenuExit.onClick   = @ExitClick

MenuFile.Add(MenuNew)
MenuFile.Add(MenuOpen)
MenuFile.Add(MenuSave)
MenuFile.Add(MenuSaveAs)
MenuFile.Add(N1)
MenuFile.Add(MenuExit)

MenuWindows.Caption = "Windows"
MenuCascade.Caption = "Cascade"
MenuCascade.onClick = @CascadeClick
MenuArrange.Caption = "Arrange"
MenuArrange.onClick = @ArrangeClick
MenuTile.Caption    = "Tile"
MenuTile.onClick    = @TileClick

MenuWindows.Add(MenuCascade)
MenuWindows.Add(MenuArrange)
MenuWindows.Add(MenuTile)

Menu.Add(MenuFile)
Menu.Add(MenuWindows)

Form.onClose = @FormClose

Form.WindowMenu = MenuWindows

Form.Menu = Menu

Form.FormStyle = 1

Form.Parent = 0

for i as integer = 0 to ubound(MDIForm)-1
    MDIForm(i).Parent = Form
next i

dim as TDialog Dialog

Dialog.onClose = @DialogClose

Dialog.Parent = Form



dim as msg m
while GetMessage(@m,0,0,0)>0
   TranslateMessage(@m)
   DispatchMessage(@m)
wend
